# Hierarchical Taxonomy Importer

This module allows for the import of taxonomy terms with parent-child relationships from a CSV file into Drupal taxonomies. It supports deep hierarchical structures with unlimited nesting levels.

## Features

- Import hierarchical taxonomy terms from CSV files
- Support for multiple levels of taxonomy hierarchy
- User-friendly interface with vocabulary selection
- Built with Drupal 8, 9, 10, 11 and 12 compatibility

## Requirements

- Drupal 8, 9, 10, 11 or 12
- PHP 8.1 or higher
- Taxonomy module enabled

## Installation

1. Download and place the module in your `/modules/contrib` directory.
2. Enable the module via the UI at Administration > Extend or use Drush:

## CSV File Format

Your CSV file should follow this format:
- Each row represents a term or term relationship
- Each column represents a level in the hierarchy
- Empty cells indicate that the term inherits its parent from the previous row

Example:

Electronics,,,
,Computers,,
,,Laptops,
,,,Gaming Laptops
,,,Business Laptops

## Usage

1. Install and enable the module.
2. Navigate to **Admin > Configuration > Development > Taxonomy Importer**.
3. Select the target vocabulary from the dropdown.
4. Upload your CSV file (must have a .csv extension).
5. Click the Import button to start the import process.

## Known Limitations

- The importer doesn't update existing taxonomy terms; it only creates new ones.
- For large CSV files, the import may time out due to PHP execution limits.
- Complex hierarchies may require multiple passes to build completely.

## Future Improvements

1. Add support for updating existing taxonomy terms
2. Implement batch processing for large imports
3. Add validation and preview options
4. Add test coverage
5. Add export functionality
6. Support multilingual taxonomy term import

## Troubleshooting

- If you encounter timeout issues, consider splitting your CSV file into smaller chunks.
- Verify that your CSV file uses commas as separators and follows the expected format.
- Check Drupal logs for detailed error messages.

## Contribution

Contributions are welcome! Please add your suggestions or bug reports to the issue queue on the project page.

## License

This project is licensed under the GPL v2 or later.
